/*
Plugin of Miranda IM for communicating with users of the AIM protocol.
Copyright (c) 2008-2009 Boris Krasnovskiy
Copyright (C) 2005-2006 Aaron Myles Landwehr

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef AVATARS_H
#define AVATARS_H

struct avatar_req_param
{
    char* sn;
    char* hash;

    avatar_req_param(char* tsn, char* thash)
    { sn = tsn; hash = thash; }

    ~avatar_req_param()
    { mir_free(sn); mir_free(hash); }
};

int detect_image_type(const char* stream, const char* &type_ret);
int detect_image_type(const char* file);
bool get_avatar_hash(const char* file, char* hash, char** data, unsigned short &size);

#endif
